//
//  FaceppResult.h
//  FaceppSDK+Demo
//
//  Created by youmu on 12-11-27.
//  Copyright (c) 2012 Megvii. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "FaceppError.h"

@interface FaceppResult : NSObject

/*!
 *  @brief indicate whether the request is successful
 */
@property BOOL success;

/*!
 *  @brief if request is not successful, all errorMessage, httpResponseStatusCode and errorCode would be stored in this struct
 */
@property (nonatomic, retain) FaceppError *error;

/*!
 *  @brief restore the JSON result which generated by NSJSONSerialization, watch the document at http://developer.apple.com/library/ios/#documentation/Foundation/Reference/NSJSONSerialization_Class/Reference/Reference.html to get more information
 */
@property (nonatomic, retain) NSDictionary *content;




-(id) initWithSuccess: (BOOL) success: (FaceppError*) error;
+(id) resultWithSuccess: (BOOL) success: (FaceppError*) error;

@end
